﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using AutoMapper;
using Microsoft.AspNetCore.Identity;
using BootstrapTable.Wenzhixi;
using Models;
using Models.Mappings;
using System.Reflection;

namespace Controllers
{
  public class RoleController : Controller
  {
    private readonly IMapper mapper;
    private readonly RoleManager<IdentityRole> RoleManager;

    public RoleController(RoleManager<IdentityRole> roleManager)
    {
      RoleManager = roleManager;

      // Setup AutoMapper between Resource and Entity
      var config = new AutoMapper.MapperConfiguration(cfg =>
      {
        cfg.AddProfiles(typeof(RoleMapping).GetTypeInfo().Assembly);
      });

      mapper = config.CreateMapper();
    }


    public IActionResult Index()
    {
      return View();
    }

    [HttpGet()]
   // [Route("[controller]/[action]")]
    public IActionResult MetaData()
    {
      var tableCreator = new BootStrapTableCreator<RoleListModel>()
      {
        AllowEdit = true,
        AllowDelete = true
      };

      return tableCreator.Serialize();
    }


    [HttpGet()]
    //[Route("[controller]/[action]")]
    public IActionResult Load(String sort, String order, Int32 offset, Int32 limit, String search)
    {
      var tableData = new BootStrapTableData<RoleListModel>(RoleManager.Roles, sort, order, offset, limit, search, mapper);

      return tableData.Serialize();
    }
  }
}