﻿using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace Models
{
  public class AccountListModel
  {
    [Key]
    [HiddenInput(DisplayValue = false)]
    [Display(Name = "User Id", ShortName = "Id", AutoGenerateFilter = false)]
    public String Id { get; set; }
        
    [CrudTitle]
    [DisableSorting]
    [Display(Name = "User name", ShortName = "User", AutoGenerateFilter = false)]
    public String UserName { get; set; }

    [CrudTitle]
    [OrderByAttributeAttribute(ListSortDirection.Ascending)]    
    public String Email { get; set; }

    [Display(Name = "Email confirmed", ShortName = "Confirmed")]
    public Boolean EmailConfirmed { get; set; }

    public String PhoneNumber { get; set; }

    [Display(Name = "Phone number confirmed", ShortName = "Confirmed")]
    public Boolean PhoneNumberConfirmed { get; set; }

    [Display(Name = "Lockout ends at", ShortName = "Lockout end")]
    public DateTimeOffset? LockoutEnd { get; set; }

    [Display(Name = "Lockout enabled")]
    public Boolean LockoutEnabled { get; set; }

    public Int32 AccessFailedCount { get; set; }
  }
}
